/*
 * Created by Finn Hakansson (finn@df.lth.se)
 *
 * See Reaction.cpp for copyright notes.
 */

#pragma once
#pragma export on
extern "C" {
extern void module_initialize(void* theInSettings, long theInSettingsSize);
extern void module_cleanup(void** theOutSettings, long* theOutSettingsSize);
extern void module_start_saving(BView* theView);
extern void module_stop_saving();
extern void module_start_config(BView* theView);
extern void module_stop_config();
}
#pragma export reset

class ReactionThread
{
public:
  ReactionThread(BView* theView);
  virtual ~ReactionThread();
  bool isInitialized();
  void Draw(BRect theUpdateRect);
  static void SetSpeed(uint32 theNewSpeed);
  static uint32 Speed();
private:
  void Save();
  bool React();
  void Clear();
  bool Reacted();
  void InitScreen();
  bool OutsideRealRadius();
  bool OnRealRadius();
  double distance(double x1, double y1, double x2, double y2);
  static long proc(void* theData);
  enum { NUMBER_OF_COLORS = 6 };
  sem_id mySemaphore;
  thread_id myThread;
  BView* myView;
  uint32 myScreenWidth;
  uint32 myScreenHeight;
  uint8** myReaction;
  uint32 myXMiddle;
  uint32 myYMiddle;
  double myRealRadius;
  uint32 myMaxRadius;
  uint32 myXPosition;
  uint32 myYPosition;
  uint32 myColorIndex;
  rgb_color myColors[NUMBER_OF_COLORS];
  bool iAmFresh;
  bool iAmInitialized;
  static uint32 mySpeed;
};

class MiniReactView : public BView
{
public:
  MiniReactView(BRect theFrame);
  void Draw(BRect theUpdateRect);
};

class SpeedSliderFilter : public BMessageFilter
{
public:
  SpeedSliderFilter(BSlider* theSpeedSlider);
  filter_result Filter(BMessage* theMessage, BHandler** theBHandler);
private:
  BSlider* mySpeedSliderRef;
};
